﻿using Proto;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        ActorSystem actorSystem = new ActorSystem();

        actorSystem.EventStream.SubscribeToTopic<TopicMessage>("Topic.*", x => Console.WriteLine($"메시지 : {x.Name} - {x.Topic}"));

        actorSystem.EventStream.Publish(new TopicMessage("홍길동", "Topic.Cosmos"));

        actorSystem.EventStream.Publish(new TopicMessage("홍길동", "AnotherTopic"));

        actorSystem.EventStream.Publish(new TopicMessage("김철수", "Topic.Computer"));

        Console.WriteLine("프로그램을 종료하기 위해서 아무 키나 눌러 주시기 바랍니다.");

        Console.ReadKey(false);
    }

    #endregion
}